diff --git a/channels/chan_dahdi.c b/channels/chan_dahdi.c
index 7b77e84..c8b3656 100644
--- a/channels/chan_dahdi.c
+++ b/channels/chan_dahdi.c
@@ -8360,6 +8360,10 @@ static struct ast_frame *dahdi_read(struct ast_channel *ast)
 	void *readbuf;
 	struct ast_frame *f;
 
+	if (!p) {
+		return NULL;
+	}
+
 	while (ast_mutex_trylock(&p->lock)) {
 		CHANNEL_DEADLOCK_AVOIDANCE(ast);
 	}
